#include <mbed.h>
#include <Pacer.h>

#include "motors.h"
#include "encoders.h"
#include "leds.h"
#include "pc_serial.h"
#include "test.h"
#include "reckoner.h"

int __attribute__((noreturn)) main()
{
    pc.baud(115200);
    
    // Enable pull-ups on encoder pins and give them a chance to settle.
    encodersInit();
    motorsInit();

    // Test routines
    //testMotors();
    //testEncoders();
    //testLineSensors();
    testReckoner();

    while(1)
    {

    }
}

void updateReckonerFromEncoders()
{
    while(encoderBuffer.hasEvents())
    {
        PololuEncoderEvent event = encoderBuffer.readEvent();
        switch(event)
        {
            case ENCODER_LEFT | POLOLU_ENCODER_EVENT_INC:
                reckoner.handleTickLeftForward();
                break;
            case ENCODER_LEFT | POLOLU_ENCODER_EVENT_DEC:
                reckoner.handleTickLeftBackward();
                break;
            case ENCODER_RIGHT | POLOLU_ENCODER_EVENT_INC:
                reckoner.handleTickRightForward();
                break;
            case ENCODER_RIGHT | POLOLU_ENCODER_EVENT_DEC:
                reckoner.handleTickRightBackward();
                break;
                   
        }
    }
}
